namespace org.accordproject.ciceromark;
using org.accordproject.commonmark;
using AccordProject.Concerto.Metamodel;
using AccordProject.Concerto;
[AccordProject.Concerto.Type(Namespace = "org.accordproject.ciceromark", Version = "0.5.0", Name = "Element")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public abstract class Element : Child {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.ciceromark@0.5.0.Element";
   public string name { get; set; }
   public string elementType { get; set; }
   public Decorator?[] decorators { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.ciceromark", Version = "0.5.0", Name = "Variable")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Variable : Element {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.ciceromark@0.5.0.Variable";
   public string value { get; set; }
   public string identifiedBy { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.ciceromark", Version = "0.5.0", Name = "FormattedVariable")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class FormattedVariable : Variable {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.ciceromark@0.5.0.FormattedVariable";
   public string format { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.ciceromark", Version = "0.5.0", Name = "EnumVariable")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class EnumVariable : Variable {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.ciceromark@0.5.0.EnumVariable";
   public string[] enumValues { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.ciceromark", Version = "0.5.0", Name = "Formula")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Formula : Element {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.ciceromark@0.5.0.Formula";
   public string value { get; set; }
   public string[] dependencies { get; set; }
   public string code { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.ciceromark", Version = "0.5.0", Name = "Block")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public abstract class Block : Element {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.ciceromark@0.5.0.Block";
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.ciceromark", Version = "0.5.0", Name = "Clause")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Clause : Block {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.ciceromark@0.5.0.Clause";
   public string src { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.ciceromark", Version = "0.5.0", Name = "Conditional")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Conditional : Block {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.ciceromark@0.5.0.Conditional";
   public bool isTrue { get; set; }
   public Child[] whenTrue { get; set; }
   public Child[] whenFalse { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.ciceromark", Version = "0.5.0", Name = "Optional")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Optional : Block {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.ciceromark@0.5.0.Optional";
   public bool hasSome { get; set; }
   public Child[] whenSome { get; set; }
   public Child[] whenNone { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.ciceromark", Version = "0.5.0", Name = "ListBlock")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class ListBlock : Block {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.ciceromark@0.5.0.ListBlock";
   public string type { get; set; }
   public string tight { get; set; }
   public string start { get; set; }
   public string delimiter { get; set; }
}
